import type { TObject, Static } from '@sinclair/typebox';
import type { WhereDefine, USchema } from '../../base/types';
import type { TableOptions } from '../../base/BaseView';
import { BaseQuery } from './BaseQuery';
import type { SearchRequest, SearchResponse, SearchHit } from '@elastic/elasticsearch/lib/api/types';
export declare class View<T extends TObject> extends BaseQuery<T> {
    protected _index: string;
    protected _CONFIG: {
        key: string;
        mark: any;
        pageSize: number;
        FIELD_MAP: Map<string, USchema>;
        WHERE_FIX: [string, string];
        BASE_QUERY: SearchRequest;
    };
    protected _QUERY_CACHE: Map<string, WhereDefine>;
    all(): Promise<SearchHit<Static<T>>[]>;
    /**
     * Exec A Senctence
    */
    sql(request?: SearchRequest): Promise<SearchResponse<Static<T>>>;
    /**
     * @param tableName Data table name, "${schemaName}.${tableName}"
     *  "${schemaName}." can be ignore with the default search_path.
     * @param schema The Object Schema, oor will not validate the value
     * @param options (Table/View) Options
     *
    */
    constructor(indexName: string, schema: T, options?: TableOptions);
}
