"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.flatExecutor = exports.executor = void 0;
const Util_1 = require("../../base/Util");
exports.executor = {
    query: (client, index, body = null) => __awaiter(void 0, void 0, void 0, function* () {
        let param = Object.assign({ index }, body);
        let result = yield client.search(param);
        return result.hits.hits;
    }),
    add: (client, index, doc) => __awaiter(void 0, void 0, void 0, function* () {
        (0, Util_1.ShowSql)(index, doc);
        const result = yield client.index({ op_type: 'create', index, document: doc });
        if (result.result == 'created') {
            return result;
        }
        throw new Error();
    }),
    get: (client, index, id) => __awaiter(void 0, void 0, void 0, function* () {
        (0, Util_1.ShowSql)(index, id);
        const result = yield client.getSource({ id, index });
        return result;
    }),
    update: (client, index, PARAM) => __awaiter(void 0, void 0, void 0, function* () {
        // ShowSql(SQL, PARAM)
        // const result = await conn.query(SQL, PARAM);
        // return result.rowCount;
        // client.update({})
        return 1;
    }),
    delete: (client, index, PARAM) => __awaiter(void 0, void 0, void 0, function* () {
        // ShowSql(SQL, PARAM)
        // const result = await conn.query(SQL, PARAM);
        // return result.rowCount;
        // client.deleteByQuery({index:''})
        client.delete({ id: '', index });
        return 1;
    }),
};
exports.flatExecutor = {
    query: (client, index, body = null) => __awaiter(void 0, void 0, void 0, function* () {
        let result = yield exports.executor.query(client, index, body);
        return result.map(item => item._source);
    }),
    add: exports.executor.add,
    get: exports.executor.get,
    update: exports.executor.update,
    delete: exports.executor.delete,
};
