"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = __importDefault(require("lodash"));
const fastify_plugin_1 = __importDefault(require("fastify-plugin"));
const pg_1 = require("pg");
const index_1 = require("../pg/index");
const OOR_FASTIFY_PG = (fastify, options, next) => {
    let oorConfig = {
        pageSize: options.pageSize || 10,
        showSQL: options.showSQL || console.debug,
        strict: options.strict || false,
    };
    lodash_1.default.unset(options, 'pageSize');
    lodash_1.default.unset(options, 'showSQL');
    lodash_1.default.unset(options, 'strict');
    const pool = new pg_1.Pool(options);
    (0, index_1.setup)(Object.assign(Object.assign({}, oorConfig), { provider: () => pool }));
    fastify.addHook('onClose', () => pool.end());
    fastify.decorate('oor', pool);
    pool.connect(next);
};
exports.default = (0, fastify_plugin_1.default)(OOR_FASTIFY_PG, { fastify: '4.x', name: '@fastify/oor' });
